#!/bin/sh
#
# ./upgrade.sh  /tmp  /tmp/sd/upgrade_170503.tar
# ./upgrade.sh  /tmp  /tmp/sd/upgrade_dir


UPGRADE_log=/tmp/run/upgrade_flag.log

#make sure not reenter upgrade processing 
while read line
do  
flag=$line
done < ${UPGRADE_log}

if [ "X${flag}" == "X1" ]; then
   echo "it is updating now and can not be updated again...";
   exit 9;
fi 
     
echo 1 > ${UPGRADE_log}
echo "begin updating now,pls waiting..."




UPGRADE_FROM=$1/upgrade
UPGRADE_SH=$1/upgrade/App_Upgrade.sh
UPGRADE_TO=/

upgradeSrc=$2

echo tmp dir is ${UPGRADE_FROM}
echo upgrade source is ${upgradeSrc}



if [ -d ${UPGRADE_FROM} ]; then
	 rm -rf ${UPGRADE_FROM}
fi

wrap_exit()
{
   	ret=$1;
   	rm -rf  ${UPGRADE_FROM}
   	echo 0 > ${UPGRADE_log}	 
	exit ${ret} 	
	
}

mkdir -p ${UPGRADE_FROM}
if [ -d ${upgradeSrc} ]; then
   cp -rfp ${upgradeSrc}/*   ${UPGRADE_FROM}/
   if [ $? -ne 0 ];    then
      wrap_exit $? 
   fi   
   echo "is dir!!\n"
   wrap_exit 0
else   
	 echo "tar -xf.......\n"
   tar -xf ${upgradeSrc} -C ${UPGRADE_FROM}
   if [ $? -ne 0 ];    then
      wrap_exit $?  
   fi
fi   

if [ -e ${UPGRADE_SH} ]
then
   chmod 777 ${UPGRADE_SH};
   if [ -x ${UPGRADE_SH} ]
   then
      echo "excute ${UPGRADE_SH} ...\n";
      ${UPGRADE_SH};
      if [ "X$?" != "X0" ]; then 
         echo "\nERROR: Failed to excute ${UPGRADE_SH} ...\n"; 
         wrap_exit 30 
      fi
    else
      echo "err,can't excute ${UPGRADE_SH}\n";
      wrap_exit 31
    fi		
	 
else
   cp -rfp ${UPGRADE_FROM}/*  ${UPGRADE_TO}
   if [ $? -eq 0 ];    then
      echo "ezdvr done"
   else
      wrap_exit $?     
   fi      
fi
   
rm -r ${UPGRADE_FROM}

wrap_exit 0 





